# -*- coding: utf-8 -*-
#
# TurboGears documentation build configuration file
#
# This file is execfile()d with the current directory set to its containing dir.
#
# Note that not all possible configuration values are present in this
# autogenerated file.
#
# All configuration values have a default; values that are commented out
# serve to show the default.

import sys, os

from tg.release import version as tg_release_version

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
sys.path.insert(0, os.path.abspath('.'))

# -- General configuration -----------------------------------------------------

# If your documentation needs a minimal Sphinx version, state it here.
needs_sphinx = '1.0'

# Add any paths that contain templates here, relative to this directory.
templates_path = ['_templates']

# The suffix of source filenames.
source_suffix = '.rst'

# The encoding of source files.
#source_encoding = 'utf-8-sig'

# The master toctree document.
master_doc = 'index'

# General information about the project.
project = u'TurboGears'
copyright_year = '2010'
copyright = copyright_year + u' by the TurboGears Doc Team'
project_url = 'http://www.turbogears.org'

# The version info for the project you're documenting, acts as replacement for
# |version| and |release|, also used in various other places throughout the
# built documents.
#
# The short X.Y version.
version = '2.1'
# The full version, including alpha/beta/rc tags.
release = max(tg_release_version, version)

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#language = None

# There are two options for replacing |today|: either, you set today to some
# non-false value, then it is used:
#today = ''
# Else, today_fmt is used as the format for a strftime call.
#today_fmt = '%B %d, %Y'

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
exclude_patterns = ['_build']

# The reST default role (used for this markup: `text`) to use for all documents.
#default_role = None

# If true, '()' will be appended to :func: etc. cross-reference text.
#add_function_parentheses = True

# If true, the current module name will be prepended to all description
# unit titles (such as .. function::).
#add_module_names = True

# If true, sectionauthor and moduleauthor directives will be shown in the
# output. They are ignored by default.
#show_authors = False

# The name of the Pygments (syntax highlighting) style to use.
#pygments_style = 'sphinx'

# A list of ignored prefixes for module index sorting.
#modindex_common_prefix = []


# -- Options for HTML output ---------------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
html_theme = 'tgtheme'

# Theme options are theme-specific and customize the look and feel of a theme
# further.  For a list of options available for each theme, see the
# documentation.
html_theme_options = dict()

# Add any paths that contain custom themes here, relative to this directory.
html_theme_path = ['.']

# The name for this set of Sphinx documents.  If None, it defaults to
# "<project> v<release> documentation".
#html_title = None

# A shorter title for the navigation bar.  Default is the same as html_title.
#html_short_title = None

# The name of an image file (relative to this directory) to place at the top
# of the sidebar.
#html_logo = None

# The name of an image file (within the static path) to use as favicon of the
# docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
# pixels large.
#html_favicon = None

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ['_static']

# If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
# using the given strftime format.
#html_last_updated_fmt = '%b %d, %Y'

# If true, SmartyPants will be used to convert quotes and dashes to
# typographically correct entities.
#html_use_smartypants = True

# Custom sidebar templates, maps document names to template names.
html_sidebars = {
    '*': ['globaltoc.html', 'sourcelink.html'],
    '*/**': ['localtoc.html', 'relations.html', 'sourcelink.html'],
}

# Additional templates that should be rendered to pages, maps page names to
# template names.
#html_additional_pages = {}

# If false, no module index is generated.
#html_domain_indices = True

# If false, no index is generated.
#html_use_index = True

# If true, the index is split into individual pages for each letter.
#html_split_index = False

# If true, links to the reST sources are added to the pages.
html_show_sourcelink = False

# If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
#html_show_sphinx = True

# If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
#html_show_copyright = True

# If true, an OpenSearch description file will be output, and all pages will
# contain a <link> tag referring to it.  The value of this option must be the
# base URL from which the finished HTML is served.
#html_use_opensearch = ''

# This is the file name suffix for HTML files (e.g. ".xhtml").
#html_file_suffix = None

# Output file base name for HTML help builder.
htmlhelp_basename = 'TG2doc'


# -- Options for LaTeX output --------------------------------------------------

# The paper size ('letter' or 'a4').
#latex_paper_size = 'letter'

# The font size ('10pt', '11pt' or '12pt').
#latex_font_size = '10pt'

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title, author, documentclass [howto/manual]).
latex_documents = [
  ('index', 'TurboGears.tex', u'TurboGears Documentation',
   u'The TurboGears Doc Team', 'manual'),
]

# The name of an image file (relative to this directory) to place at the top of
# the title page.
#latex_logo = None

# For "manual" documents, if this is true, then toplevel headings are parts,
# not chapters.
#latex_use_parts = False

# If true, show page references after internal links.
#latex_show_pagerefs = False

# If true, show URL addresses after external links.
#latex_show_urls = False

# Additional stuff for the LaTeX preamble.
#latex_preamble = ''

# Documents to append as an appendix to all manuals.
#latex_appendices = []

# If false, no module index is generated.
#latex_domain_indices = True


# -- Options for ePub output ---------------------------------------------------

epub_basename = 'TurboGears_2.1'
epub_title = 'TurboGears Documentation for Version ' + release
epub_author = 'TurboGears Documentation Team'
epub_language = 'en'
epub_publisher = 'TurboGears'
epub_identifier = 'http://www.turbogears.org'
epub_scheme = 'URL'
epub_pre_files = []
epub_post_files = []
epub_exclude_files = [
    '_static/doctools.js', '_static/jquery.js', '_static/sidebar.js',
    '_static/searchtools.js', '_static/underscore.js',
    '_static/screenshot.tiff', '_static/turbogears.pdf',
    '_static/trunk.zip',
    '_static/ToscaWidgetsFormsExample.zip', '_static/Wiki20_final.zip',
    '_static/tutorials/Helloworld.zip', '_static/tutorials/Wiki-20.zip',
    '_static/tutorials/sqlautocode/moviedemo.db'
]
epub_tocdepth = 2


# -- Options for manual page output --------------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    ('index', 'turbogears', u'TurboGears Documentation',
     [u'The TurboGears Doc Team'], 1)
]


# -- Options for Extension -----------------------------------------------------

# Add any Sphinx extension module names here, as strings. They can be extensions
# coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
extensions = [
    'sphinx.ext.autodoc', 'sphinx.ext.intersphinx',
    'sphinx.ext.coverage', 'sphinx.ext.todo',
    'code_ext' # TurboGears code documentation extensions
]

# Specify whether todo items shall be created in the output
todo_include_todos = True

# Add Intersphinx crosslinks here
intersphinx_mapping = {
    'paste': ('http://pythonpaste.org', None),
    'pylons': ('http://docs.pylonsproject.org/projects/pylons_framework/dev/', None),
    'python': ('http://docs.python.org', None),
    'sprox': ('http://sprox.org', None),
    'sqlalchemy': ('http://www.sqlalchemy.org/docs', None),
    'rum': ('http://docs.python-rum.org', None),
    'tw': ('http://toscawidgets.org/documentation/ToscaWidgets/', None),
    'twdynforms': ('http://toscawidgets.org/documentation/tw.dynforms/', None),
    'twforms': ('http://toscawidgets.org/documentation/tw.forms/', None),
    'twjquery': ('http://toscawidgets.org/documentation/tw.jquery/', None),
    'webob': ('http://pythonpaste.org/webob/', None),
    'webtest': ('http://pythonpaste.org/webtest/', None),
}

# The maximum number of days to cache remote inventories.
# The default is 5, meaning five days.
# Set this to a negative value to cache inventories for unlimited time.
#intersphinx_cache_limit = 5

# Ihe options for the TurboGears code documentation extensions

code_scm = 'svn'
code_path = test_path = 'project_code'

